#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Created following Conbagui tutorial found here: https://www.deviantart.com/conbagui/art/Create-a-Notebook-with-Gimp-2-10-793839052

# author: Pocholo
# date: 1/6/22

# Comments directed to http://gimpchat.com

# Installation:
# This script should be placed in the user plugin folder

# Copyright (C)

#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by   
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.

#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <https://www.gnu.org/licenses/>.

from gimpfu import *
import os, string, sys,time
import gettext
gettext.install("gimp20", gimp.locale_directory, unicode=True)

def create_a_notebook(customtext, font, textColor):
		
    #Initiates the temporary state
    pdb.gimp_context_push()
    pdb.gimp_context_set_defaults()
    
    
    #Create new canvas to work on
    width = 1600
    height = 1200
    #Leather background
    img = pdb.gimp_image_new(width, height, RGB)
    backLayer = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Background", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, backLayer, 0)
    pdb.gimp_context_set_foreground((103, 54, 95))
    pdb.gimp_drawable_fill(backLayer, FILL_FOREGROUND)
	
	#Process
    pdb.gimp_display_new(img)
	
	#Color overlay
    colorOLayer = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Color Overlay", 100, LAYER_MODE_SCREEN)
    pdb.gimp_image_add_layer(img, colorOLayer, 0)
    pdb.gimp_context_set_foreground((43, 43, 43))
    pdb.gimp_drawable_fill(colorOLayer, FILL_FOREGROUND)
    pdb.gimp_context_set_foreground((255, 255, 255))
    pdb.gimp_context_set_background((0, 0, 0))
    pdb.plug_in_mosaic(img, colorOLayer, 
									 12, 
									2.0, 
									  1, 
								    0.0, 
									  0, 
									103, 
									  0, 
									  1, 
									  0, 
							          1, 
									  1, 
									  1)
    pdb.plug_in_mosaic(img, colorOLayer, 
									 12, 
									2.0, 
									  1, 
								    0.0, 
									  0, 
									103, 
									  0, 
									  1, 
									  0, 
							          1, 
									  0, 
									  1)
    
    #Slightly fold
    foldLayer = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Slight fold", 27, LAYER_MODE_SOFTLIGHT)
    pdb.gimp_image_add_layer(img, foldLayer, 0)
    pdb.gimp_context_set_foreground("White")
    pdb.gimp_drawable_fill(foldLayer, FILL_FOREGROUND)   
    pdb.plug_in_solid_noise(img, foldLayer, TRUE, FALSE, 0, 15, 2, 0.7)
    
    #Merge all layers
    backLayer = pdb.gimp_image_merge_visible_layers(img, CLIP_TO_BOTTOM_LAYER)
    
    #Create the front cover flipped on the bottom
    coverLayer = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Front cover", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, coverLayer, 0)
    pdb.gimp_drawable_fill(coverLayer, FILL_TRANSPARENT)
    pdb.gimp_context_set_foreground((68, 44, 255))
    pdb.gimp_image_select_rectangle(img, 2, 450, 150, 700, 900)
    pdb.gimp_edit_bucket_fill(coverLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.gimp_selection_none(img)
    coverLayer = pdb.gimp_item_transform_shear(coverLayer,  ORIENTATION_VERTICAL, 20)
    
    #Front cover drop shadow
    dropshaLayer = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Front cover dropshadow", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, dropshaLayer, 1)
    pdb.gimp_drawable_fill(dropshaLayer, FILL_TRANSPARENT)
    pdb.gimp_image_select_item(img, 2, coverLayer)
    pdb.gimp_context_set_foreground("Black")
    pdb.gimp_edit_bucket_fill(dropshaLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.gimp_selection_none(img)
    pdb.gimp_layer_set_offsets(dropshaLayer, 4, 4)
    dropshaLayer = pdb.gimp_image_merge_down(img, coverLayer, CLIP_TO_IMAGE)
    coverLayer = pdb.gimp_image_get_layer_by_name(img, "Front cover dropshadow")
    pdb.gimp_item_set_name(coverLayer, "Front cover")
    
    #Create back cover
    #Create the front cover flipped on the bottom
    coverLayer2 = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, " Back cover", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, coverLayer2, 0)
    pdb.gimp_drawable_fill(coverLayer2, FILL_TRANSPARENT)
    pdb.gimp_context_set_foreground((117, 117, 117))
    pdb.gimp_image_select_rectangle(img, 2, 450, 150, 700, 900)
    pdb.gimp_edit_bucket_fill(coverLayer2, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.gimp_selection_none(img)
    coverLayer2 = pdb.gimp_item_transform_shear(coverLayer2, ORIENTATION_VERTICAL, -10)
    
    #Back cover drop shadow
    dropshaLayer2 = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Back cover dropshadow", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, dropshaLayer2, 1)
    pdb.gimp_drawable_fill(dropshaLayer2, FILL_TRANSPARENT)
    pdb.gimp_image_select_item(img, 2, coverLayer2)
    pdb.gimp_context_set_foreground("Black")
    pdb.gimp_edit_bucket_fill(dropshaLayer2, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.gimp_selection_none(img)
    pdb.gimp_layer_set_offsets(dropshaLayer2, 4, 4)
    dropshaLayer2 = pdb.gimp_image_merge_down(img, coverLayer2, CLIP_TO_IMAGE)
    coverLayer2 = pdb.gimp_image_get_layer_by_name(img, "Back cover dropshadow")
    pdb.gimp_item_set_name(coverLayer2, "Back cover")
    coverLayer = pdb.gimp_image_merge_down(img, coverLayer2, CLIP_TO_IMAGE)
    coverLayer = pdb.gimp_image_get_layer_by_name(img, "Front cover")
    pdb.gimp_item_set_name(coverLayer, "Notebook cover")
    
   #Create the pages and lines
    pagesLayer = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Pages", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, pagesLayer, 0)
    pdb.gimp_drawable_fill(pagesLayer, FILL_TRANSPARENT)
    pdb.gimp_context_set_foreground("White")
    pdb.gimp_context_set_background((3, 113, 250))
    pdb.gimp_image_select_rectangle(img, 2, 450, 160, 700, 880)
    pdb.gimp_edit_bucket_fill(pagesLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.gimp_image_select_rectangle(img, 3, 500, 250, 650, 790)
    pdb.plug_in_grid(img, pagesLayer, 
                                   3,   #hwidth 
                                  40,   #hspace 
                                   4,   #hoffset 
                       (3, 113, 250),   #hcolor 
                                 255,   #hopacity 
                                   0,   #vwidth 
                                1600,   #vspace 
                                   0,   #voffset 
                        (0, 0, 0, 0),   #vcolor 
                                 255,   #vopacity 
                                   0,   #iwidth 
                                   0,   #ispace 
                                   0,   #ioffset
                        (0, 0, 0, 0),   #icolor 
                                255)    #iopacity
    pdb.gimp_selection_none(img)
    
    #Create the holes on the page and covers
    pdb.gimp_context_set_brush("2. Block 01")
    pdb.gimp_context_set_brush_size(40)
    pdb.gimp_context_set_brush_aspect_ratio(0.10)
    pdb.gimp_context_set_brush_angle(0)
    pdb.gimp_context_set_brush_spacing(11.6)
    pdb.gimp_context_set_brush_default_hardness()
    pdb.gimp_context_set_brush_force(1)
    pdb.gimp_eraser_default(pagesLayer, 4, [475, 200, 475, 1000])
    pdb.gimp_eraser_default(coverLayer, 4, [475, 200, 475, 1000])
    
    #Inner shadow
    pagesInner = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Layer", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, pagesInner, 0)
    pdb.gimp_drawable_fill(pagesInner, FILL_TRANSPARENT)
    pdb.gimp_context_set_foreground("Black")
    pdb.gimp_image_select_item(img, 2, pagesLayer)
    pdb.gimp_edit_bucket_fill(pagesInner, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.gimp_selection_shrink(img, 1)
    pdb.gimp_drawable_edit_clear(pagesInner)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_item(img, 2, pagesLayer)
    pdb.plug_in_gauss(img, pagesInner, 1, 1, 1)   #method=1
    pdb.gimp_selection_none(img)
    pagesLayer = pdb.gimp_image_merge_down(img, pagesInner, CLIP_TO_IMAGE)
    
    #Paper drop shadow
    pdb.script_fu_drop_shadow(img, pagesLayer, 5, 5, 2, ("Black"), 75, FALSE)
    dropshadLayer = pdb.gimp_image_get_layer_by_name(img, "Drop Shadow")
    pagesLayer = pdb.gimp_image_merge_down(img, pagesLayer, CLIP_TO_IMAGE)
    pdb.gimp_item_set_name(pagesLayer, "Pages")
    
    #Create 5 paper copies
    #2
    non_empty = pdb.gimp_edit_copy(pagesLayer)
    page2Layer = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Page #2", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, page2Layer, 0)
    pdb.gimp_drawable_fill(page2Layer, FILL_TRANSPARENT)
    page2Layer = pdb.gimp_edit_paste(page2Layer, FALSE)
    pdb.gimp_floating_sel_anchor(page2Layer)
    page2Layer = pdb.gimp_image_get_layer_by_name(img, "Page #2")
    #3
    non_empty = pdb.gimp_edit_copy(pagesLayer)
    page3Layer = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Page #3", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, page3Layer, 0)
    pdb.gimp_drawable_fill(page3Layer, FILL_TRANSPARENT)
    page3Layer = pdb.gimp_edit_paste(page3Layer, FALSE)
    pdb.gimp_floating_sel_anchor(page3Layer)
    page3Layer = pdb.gimp_image_get_layer_by_name(img, "Page #3")
    pdb.gimp_drawable_offset(page3Layer, TRUE, 2, 4, 0)
    page3Layer = pdb.gimp_item_transform_shear(page3Layer, ORIENTATION_HORIZONTAL, -10)
    #4
    non_empty = pdb.gimp_edit_copy(pagesLayer)
    page4Layer = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Page #4", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, page4Layer, 0)
    pdb.gimp_drawable_fill(page4Layer, FILL_TRANSPARENT)
    page4Layer = pdb.gimp_edit_paste(page4Layer, FALSE)
    pdb.gimp_floating_sel_anchor(page4Layer)
    page4Layer = pdb.gimp_image_get_layer_by_name(img, "Page #4")
    pdb.gimp_drawable_offset(page4Layer, TRUE, 2, -7, 0)
    #5
    non_empty = pdb.gimp_edit_copy(pagesLayer)
    page5Layer = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Page #5", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, page5Layer, 0)
    pdb.gimp_drawable_fill(page5Layer, FILL_TRANSPARENT)
    page5Layer = pdb.gimp_edit_paste(page5Layer, FALSE)
    pdb.gimp_floating_sel_anchor(page5Layer)
    page5Layer = pdb.gimp_image_get_layer_by_name(img, "Page #5")
    pdb.gimp_drawable_offset(page5Layer, TRUE, 2, -14, 0)
    
    #Rings biding
    ringsLayer = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Rings binding", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, ringsLayer, 0)
    pdb.gimp_drawable_fill(ringsLayer, FILL_TRANSPARENT)
    pdb.gimp_context_set_foreground((80, 80, 80))
    pdb.gimp_context_set_gradient("Rounded edge")
    #First ring set
    pdb.gimp_image_select_round_rectangle(img, 2, 416, 190, 60, 8, 8, 8)
    pdb.gimp_edit_bucket_fill(ringsLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_round_rectangle(img, 2, 416, 202, 60, 8, 8, 8)
    pdb.gimp_edit_bucket_fill(ringsLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_item(img, 2, ringsLayer)
    pdb.gimp_selection_none(img)
    #Second ring set
    pdb.gimp_image_select_round_rectangle(img, 2, 416, 304, 60, 8, 8, 8)
    pdb.gimp_edit_bucket_fill(ringsLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_round_rectangle(img, 2, 416, 316, 60, 8, 8, 8)
    pdb.gimp_edit_bucket_fill(ringsLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_item(img, 2, ringsLayer)
    pdb.gimp_selection_none(img)
    #Third ring set
    pdb.gimp_image_select_round_rectangle(img, 2, 416, 417, 60, 8, 8, 8)
    pdb.gimp_edit_bucket_fill(ringsLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_round_rectangle(img, 2, 416, 430, 60, 8, 8, 8)
    pdb.gimp_edit_bucket_fill(ringsLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_item(img, 2, ringsLayer)
    pdb.gimp_selection_none(img)
    #Fourth ring set
    pdb.gimp_image_select_round_rectangle(img, 2, 416, 530, 60, 8, 8, 8)
    pdb.gimp_edit_bucket_fill(ringsLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_round_rectangle(img, 2, 416, 543, 60, 8, 8, 8)
    pdb.gimp_edit_bucket_fill(ringsLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_item(img, 2, ringsLayer)
    pdb.gimp_selection_none(img)
    #Fifth ring set
    pdb.gimp_image_select_round_rectangle(img, 2, 416, 645, 60, 8, 8, 8)
    pdb.gimp_edit_bucket_fill(ringsLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_round_rectangle(img, 2, 416, 657, 60, 8, 8, 8)
    pdb.gimp_edit_bucket_fill(ringsLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_item(img, 2, ringsLayer)
    pdb.gimp_selection_none(img)
    #Sixth ring set
    pdb.gimp_image_select_round_rectangle(img, 2, 416, 758, 60, 8, 8, 8)
    pdb.gimp_edit_bucket_fill(ringsLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_round_rectangle(img, 2, 416, 771, 60, 8, 8, 8)
    pdb.gimp_edit_bucket_fill(ringsLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_item(img, 2, ringsLayer)
    pdb.gimp_selection_none(img)
    #Seventh ring set
    pdb.gimp_image_select_round_rectangle(img, 2, 416, 872, 60, 8, 8, 8)
    pdb.gimp_edit_bucket_fill(ringsLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_round_rectangle(img, 2, 416, 885, 60, 8, 8, 8)
    pdb.gimp_edit_bucket_fill(ringsLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_item(img, 2, ringsLayer)
    pdb.gimp_selection_none(img)
    #Eighth ring set
    pdb.gimp_image_select_round_rectangle(img, 2, 416, 985, 60, 8, 8, 8)
    pdb.gimp_edit_bucket_fill(ringsLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_round_rectangle(img, 2, 416, 998, 60, 8, 8, 8)
    pdb.gimp_edit_bucket_fill(ringsLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_item(img, 2, ringsLayer)
    pdb.gimp_drawable_edit_gradient_fill(ringsLayer, 
                                                  0,  #gradient type - radial
                                                  0,  #offset
                                               TRUE,  #super sample
                                                  3,  #supersample-max depth
                                               0.20,  #supersample-threshole
                                               TRUE,  #dither
                                                408,  #x1
                                                600,  #y1
                                                475,  #x2
                                                600)  #y2
    
    pdb.gimp_selection_none(img)
    
    #Create a new visible layer
    pdb.gimp_item_set_visible(backLayer, FALSE)
    newVisible = pdb.gimp_layer_new_from_visible(img, img, "Ball point pen")
    pdb.gimp_image_add_layer(img, newVisible, 0)
    pdb.script_fu_drop_shadow(img, newVisible, -35, -35, 20, ("Black"), 35, FALSE)
    padShadow = pdb.gimp_image_get_layer_by_name(img, "Drop Shadow")
    #pdb.gimp_drawable_fill(newVisible, FILL_TRANSPARENT)
    pdb.gimp_item_set_visible(backLayer, TRUE)
    
    
    #Add a pen
    penLayer = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Pen", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, penLayer, 0)
    pdb.gimp_drawable_fill(penLayer, FILL_TRANSPARENT)
    
    #Ball point
    num_seg = 12
    segs = [895, 1131, 890, 1139, 890, 1140, 892, 1141, 899, 1135, 895, 1131]
    pointLayer = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Ball point", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, pointLayer, 0)
    pdb.gimp_drawable_fill(pointLayer, FILL_TRANSPARENT)
    pdb.gimp_context_set_foreground((85, 82, 89))
    pdb.gimp_context_set_background((174, 173, 179))
    pdb.gimp_image_select_polygon(img, 2, num_seg, segs)
    pdb.gimp_edit_bucket_fill(pointLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 895, 1135)
    pdb.gimp_edit_blend(pointLayer, 
                                 0,  #blend mode - fg to bg rgb
                 LAYER_MODE_NORMAL,  #paint mode 
                                 1,  #gradient type - bi-linear
                               100,  #opacity 
                                 0,  #offset
                                 0,  #repeat - none
                             FALSE,  #reverse
                              TRUE,  #supe-samle
                                 3,  #max depth
                              0.20,  #threshold                            
                              TRUE,  #dither
                               895,  #x1
                              1136,  #y1
                               896,  #x2
                              1137)  #y2  	
    pdb.gimp_selection_none(img)
    penLayer = pdb.gimp_image_merge_down(img, pointLayer, CLIP_TO_IMAGE)
    
    #Tip
    num_seg = 10
    segs = [895, 1130, 901, 1135, 941, 1103, 926, 1090, 895, 1130]
    tipLayer = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Tip", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, tipLayer, 0)
    pdb.gimp_drawable_fill(tipLayer, FILL_TRANSPARENT)
    pdb.gimp_context_set_foreground((18, 17, 21))
    pdb.gimp_context_set_background((255, 255, 255))
    pdb.gimp_image_select_polygon(img, 2, num_seg, segs)
    pdb.gimp_edit_bucket_fill(tipLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 918, 1111)
    pdb.gimp_edit_blend(tipLayer, 
                                 0,  #blend mode - fg to bg rgb
                 LAYER_MODE_NORMAL,  #paint mode 
                                 1,  #gradient type - bi-linear
                               100,  #opacity 
                                 0,  #offset
                                 0,  #repeat - none
                             FALSE,  #reverse
                              TRUE,  #supe-samle
                                 3,  #max depth
                              0.20,  #threshold                            
                              TRUE,  #dither
                               924,  #x1
                              1107,  #y1
                               927,  #x2
                              1110)  #y2  	
    pdb.gimp_selection_none(img)
    penLayer = pdb.gimp_image_merge_down(img, tipLayer, CLIP_TO_IMAGE)

    #Barrel
    num_seg = 22
    segs = [925, 1088, 942, 1104, 1020, 1032, 1100, 950, 1174, 877, 1225, 822, 1207, 804, 1153, 854, 1072, 935, 
            1037, 970, 925, 1088]
    barrelLayer = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Barrel", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, barrelLayer, 0)
    pdb.gimp_drawable_fill(barrelLayer, FILL_TRANSPARENT)
    pdb.gimp_context_set_foreground("Black")
    pdb.gimp_image_select_polygon(img, 2, num_seg, segs)
    pdb.gimp_edit_bucket_fill(barrelLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 918, 1111)
    pdb.gimp_context_set_gradient("Black Grey Black")
    pdb.gimp_drawable_edit_gradient_fill(barrelLayer, 
                                                   0,  #gradient type - linear
                                                   0,  #offset
                                                TRUE,  #supe-sample
                                                   3,  #max depth
                                                0.20,  #threshold
                                                TRUE,  #dither
                                                1068,  #x1
                                                 938,  #y2
                                                1090,  #x2
                                                 960)  #y2                                            	
    pdb.gimp_selection_none(img)
    
    #End cap
    layer = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Layer", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, layer, 0)
    pdb.gimp_drawable_fill(layer, FILL_TRANSPARENT)
    pdb.gimp_context_set_foreground("White")
    pdb.gimp_context_set_brush("2. Hardness 100")
    pdb.gimp_context_set_brush_size(27)
    pdb.gimp_context_set_brush_aspect_ratio(1.10)
    pdb.gimp_context_set_brush_angle(45)
    pdb.gimp_context_set_brush_spacing(0.1)
    pdb.gimp_context_set_brush_default_hardness()
    pdb.gimp_context_set_brush_force(1)
    pdb.gimp_paintbrush_default(layer, 2, [1217, 811])
    pdb.gimp_image_select_item(img, 2, layer)
    pdb.gimp_context_set_foreground((4, 4, 4))
    pdb.gimp_context_set_background((112, 112, 112))
    pdb.gimp_edit_blend(layer, 
                            0,  #blend mode - fg to bg rgb
                            0,  #paint mode - layer_mode_nrmal 
                            0,  #gradient type - linear
                          100,  #opacity 
                            0,  #offset
                            0,  #repeat - none
                        FALSE,  #reverse
                         TRUE,  #supe-samle
                            3,  #max depth
                         0.20,  #threshold                            
                         TRUE,  #dither
                         1215,  #x1
                          814,  #y1
                         1222,  #x2
                          807)  #y2  	
    pdb.gimp_selection_none(img)
    barrelLayer = pdb.gimp_image_merge_down(img, layer, CLIP_TO_IMAGE)
    
    #Center ring
    num_seg = 10
    segs = [1082, 924, 1105, 946, 1094, 957, 1071, 935, 1082, 925]
    pdb.gimp_context_set_foreground("White")
    pdb.gimp_image_select_polygon(img, 2, num_seg, segs)
    pdb.gimp_edit_bucket_fill(barrelLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 918, 1111)
    pdb.gimp_context_set_gradient("Crown Moulding 10")
    pdb.gimp_drawable_edit_gradient_fill(barrelLayer, 
                                                   0,  #gradient type - linear
                                                   0,  #offset
                                                TRUE,  #supe-sample
                                                   3,  #max depth
                                                0.20,  #threshold
                                                TRUE,  #dither
                                                1069,  #x1
                                                 925,  #y2
                                                1094,  #x2
                                                 950)  #y2
    pdb.gimp_selection_none(img)  
    
    #Top ring
    num_seg = 10
    segs = [1203, 806, 1222, 825, 1225, 822, 1206, 803, 1203, 806]
    pdb.gimp_context_set_foreground("White")
    pdb.gimp_image_select_polygon(img, 2, num_seg, segs)
    pdb.gimp_edit_bucket_fill(barrelLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 918, 1111)
    pdb.gimp_context_set_gradient("Crown Moulding 10")
    pdb.gimp_drawable_edit_gradient_fill(barrelLayer, 
                                                   0,  #gradient type - linear
                                                   0,  #offset
                                                TRUE,  #supe-sample
                                                   3,  #max depth
                                                0.20,  #threshold
                                                TRUE,  #dither
                                                1200,  #x1
                                                 800,  #y2
                                                1222,  #x2
                                                 823)  #y2
    
    pdb.gimp_selection_none(img)
    
    #Clip
    num_seg = 30
    segs = [1210, 810, 1220, 820, 1140, 900, 1108, 926, 1107, 927, 1105, 926, 1104, 926, 1104, 925, 
            1103, 923, 1102, 922, 1103, 921, 1112, 910, 1131, 890, 1210, 810]
    pdb.gimp_context_set_foreground("White")
    pdb.gimp_image_select_polygon(img, 2, num_seg, segs)
    pdb.gimp_edit_bucket_fill(barrelLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 918, 1111)
    pdb.gimp_context_set_gradient("Crown Moulding 10")
    pdb.gimp_drawable_edit_gradient_fill(barrelLayer, 
                                                   0,  #gradient type - linear
                                                   0,  #offset
                                                TRUE,  #supe-sample
                                                   3,  #max depth
                                                0.20,  #threshold
                                                TRUE,  #dither
                                                1160,  #x1
                                                 848,  #y2
                                                1177,  #x2
                                                 865)  #y2
    
    pdb.gimp_selection_none(img)  
    penLayer = pdb.gimp_image_merge_down(img, barrelLayer, CLIP_TO_IMAGE)
    
    pdb.script_fu_perspective_shadow(img, penLayer, 
	                                            82,  #angle
											   3.0,  #relative dist from horizon
												 1,  #relative length fron shadow
												 8,  #blur radius
										   "Black",  #color
												75,  #opacity
												 1,  #interpolation
											 FALSE)  #allow resizing
    
    penShadow = pdb.gimp_image_get_layer_by_name(img, "Perspective Shadow")
    pdb.gimp_layer_resize_to_image_size(penShadow)
    pdb.gimp_drawable_offset(penShadow, TRUE, 2, -7, -5)
    
    #Create text
    size = 45
    pdb.gimp_context_set_foreground(textColor)
    textLayer = pdb.gimp_text_fontname(img, None, 0, 0, customtext, 0,
                                   True, size, PIXELS, font)
    pdb.gimp_text_layer_set_justification(textLayer, 0)
    pdb.gimp_text_layer_set_line_spacing(textLayer, -14)
    textLayer = pdb.gimp_image_get_active_layer(img)
    pdb.gimp_image_set_active_layer(img, textLayer)
    wh = pdb.gimp_drawable_width(textLayer)
    hh = pdb.gimp_drawable_height(textLayer)
    w = pdb.gimp_image_width(img)
    h = pdb.gimp_image_height(img)
    pdb.gimp_image_set_active_layer(img,textLayer)
    centerx=w/2
    centery=h/2
    adw=wh/2
    adh=hh/1
    sw=centerx - adw
    sh=centery - adh		
    pdb.gimp_layer_set_offsets(textLayer, sw, sh)
    pdb.gimp_layer_resize_to_image_size(textLayer)
    pdb.gimp_drawable_offset(textLayer, TRUE, 2, 0, -225)
    pdb.gimp_layer_set_mode(textLayer, LAYER_MODE_NORMAL)
    pdb.gimp_layer_set_opacity(textLayer, 100)  
    pdb.gimp_item_set_name(textLayer, "Text")
    
    #Make active the bottom layer and done
    pdb.gimp_image_set_active_layer(img, backLayer)
    
    #Set the defaults
    pdb.gimp_context_pop()	
       
register(
    "create_a_notebook",
    "Creates an open notebook",
    "Creates an open notebook",
    "Pocholo",
    "Pocholo",
    "2022",
    "Create a Notebook",
    "",
    [
    (PF_TEXT, "customtext", "Text string", "I love GIMP and my spare time\n I like to create plugins!"),
    (PF_FONT, "font", "Font face", "Dancing Script Bold"),
    (PF_COLOR, "textColor", "Text Color:", (0, 0, 0)),
    ],
    [],
    create_a_notebook, menu="<Image>/File/Create/ Notebook",
    domain=("gimp20", gimp.locale_directory))
main()							